import java.io.*;
import java.math.BigDecimal;
import java.util.Vector;
import java.awt.*;
import java.awt.event.*;
import java.beans.PropertyChangeEvent;
import java.beans.PropertyChangeListener;

import javax.swing.*;
import javax.swing.plaf.FontUIResource;

//Version 1.0-- 2013 Jul 10
//Correlation working might be improved by removing the NA
//Correction of the default parameters and new value
//Change the parameters from matrix to list
//change the names of variables
//Add the try block runnable get back to false

public class UncertaintyMachine extends JPanel implements ActionListener {
	/**
	 * 
	 */
	private static final long serialVersionUID = 8483914984635299703L;

	JComboBox variableField;

	JTextArea expressionField;
	JFormattedTextField realisationField;

	JButton outputFileButton;
	JFileChooser outputFilefc;
	JFormattedTextField outputFileField;

	DistribLine[] distList;
	VariablesNames varNamesPanel;
	JCheckBox correlation;
	CorrelationTable coreTable;
	JPanel correlationPanel;

	JPanel fullVarNamesPanel;
	JPanel imagePanel;

	int returnVal = -1;

	boolean runnable = false;

	int nbVar = 1;

	JFileChooser paramFilefc;

	JButton saveButton;
	JButton loadButton;
	JButton resetButton;

	JButton runButton;
	JButton abortButton;
	JButton quitButton;

	File scriptFile;

	String eol = System.getProperty("line.separator");
	String softwareLocation = ".";

	String tempFile = "./launchScript.R";
	Font fontForms = new Font("arial", Font.BOLD, 15);

	Vector<Process> processList = new Vector<Process>(2, 2);
	int nbProcess;

	public UncertaintyMachine() {

		nbProcess = 0;

		String[] choice = { "1", "2", "3", "4", "5", "6", "7", "8", "9", "10",
				"11", "12", "13", "14", "15" };
		variableField = new JComboBox(choice);
		variableField.addActionListener(this);

		realisationField = new JFormattedTextField();
		realisationField.setColumns(30);
		realisationField.setText("1000000");

		expressionField = new JTextArea();
		expressionField.setColumns(30);
		expressionField.setText("x0");
		expressionField.setFont(fontForms);

		varNamesPanel = new VariablesNames(1, this);
		fullVarNamesPanel = new JPanel();
		fullVarNamesPanel.add(varNamesPanel);

		outputFilefc = new JFileChooser();
		outputFileField = new JFormattedTextField();
		outputFileField.setColumns(40);
		outputFileField.setEditable(false);
		outputFileButton = new JButton("Choose file");
		outputFileButton.addActionListener(this);

		paramFilefc = new JFileChooser();

		loadButton = new JButton("Load Parameters");
		loadButton.addActionListener(this);

		saveButton = new JButton("Save Parameters");
		saveButton.addActionListener(this);

		resetButton = new JButton("Revert to Default");
		resetButton.addActionListener(this);

		runButton = new JButton("Run");
		runButton.addActionListener(this);

		abortButton = new JButton("Abort");
		abortButton.addActionListener(this);

		quitButton = new JButton("Quit");
		quitButton.addActionListener(this);

		imagePanel = new JPanel(); // use FlowLayout

		imagePanel.setLayout(new GridLayout(0, 1));

		distList = new DistribLine[nbVar];
		for (int ij = 0; ij < nbVar; ij++) {
			distList[ij] = new DistribLine("x" + ij);
			imagePanel.add(distList[ij]);
		}
		JScrollPane scrollPane = new JScrollPane(imagePanel);
		scrollPane.setPreferredSize(new Dimension(400, 800));

		correlationPanel = new JPanel();
		correlation = new JCheckBox("Correlations");
		correlation.setSelected(false);
		correlation.addActionListener(this);

		correlationPanel.setLayout(new BorderLayout());
		correlationPanel.add(correlation, BorderLayout.CENTER);
		coreTable = new CorrelationTable(nbVar, varNamesPanel);

		JPanel buttonPanel = new JPanel(); // use FlowLayout

		JPanel filePanel = new JPanel(); // use FlowLayout

		filePanel.add(new JLabel("Save Results in file"));
		filePanel.add(outputFileField);
		filePanel.add(outputFileButton);

		JPanel varPanel = new JPanel(); // use FlowLayout
		varPanel.setLayout(new GridLayout(0, 2));
		JPanel varPanel2 = new JPanel(); // use FlowLayout
		varPanel2.setLayout(new GridLayout(0, 2));

		varPanel.add(new JLabel("Number of input quantities:"));
		varPanel.add(variableField);

		varPanel.add(new JLabel("Number of realizations of output quantity:"));
		varPanel.add(realisationField);

		varPanel2.add(new JLabel(
				"Definition of output quantity (R expression):"));
		varPanel2.add(expressionField);

		JPanel configurationFilePanel = new JPanel(); // use FlowLayout

		JPanel fileFullPanel = new JPanel(); // use FlowLayout
		fileFullPanel.add(filePanel, BorderLayout.CENTER);

		buttonPanel.add(new JLabel(" "));
		buttonPanel.add(resetButton);
		buttonPanel.add(saveButton);
		buttonPanel.add(loadButton);
		buttonPanel.add(new JLabel("                     "));

		buttonPanel.add(runButton);
		if ((System.getProperty("os.name").toLowerCase()).indexOf("win") < 0)
			buttonPanel.add(abortButton);
		buttonPanel.add(quitButton);
		configurationFilePanel.add(buttonPanel, BorderLayout.SOUTH);

		this.setLayout(new BoxLayout(this, BoxLayout.PAGE_AXIS));
		this.add(varPanel);
		this.add(fullVarNamesPanel);
		this.add(varPanel2);
		this.add(scrollPane);
		this.add(correlationPanel);
		this.add(fileFullPanel);
		this.add(configurationFilePanel);

	}

	public void updateVarNb() {
		imagePanel.removeAll();
		nbVar = variableField.getSelectedIndex() + 1;
		fullVarNamesPanel.removeAll();
		varNamesPanel = new VariablesNames(nbVar, this);
		fullVarNamesPanel.add(varNamesPanel);
		fullVarNamesPanel.updateUI();
		distList = new DistribLine[nbVar];
		for (int ij = 0; ij < nbVar; ij++) {
			distList[ij] = new DistribLine("x" + ij);
			imagePanel.add(distList[ij]);
		}

		imagePanel.updateUI();

		coreTable = new CorrelationTable(nbVar, varNamesPanel);
		correlationPanel.removeAll();
		correlationPanel.add(correlation, BorderLayout.NORTH);
		if (correlation.isSelected() == true)
			correlationPanel.add(coreTable, BorderLayout.CENTER);
		correlationPanel.updateUI();
	}

	public void updateVarNames() {
		imagePanel.removeAll();
		for (int ij = 0; ij < nbVar; ij++) {
			distList[ij].changeName(varNamesPanel.getName(ij));
			imagePanel.add(distList[ij]);
		}

		imagePanel.updateUI();

		coreTable = new CorrelationTable(nbVar, varNamesPanel);
		correlationPanel.removeAll();
		correlationPanel.add(correlation, BorderLayout.NORTH);
		if (correlation.isSelected() == true)
			correlationPanel.add(coreTable, BorderLayout.CENTER);
		correlationPanel.updateUI();

	}

	public void saveParam() {
		returnVal = paramFilefc.showOpenDialog(UncertaintyMachine.this);

		if (returnVal == JFileChooser.APPROVE_OPTION) {
			try {
				File file = paramFilefc.getSelectedFile();

				paramFilefc.setCurrentDirectory(file.getParentFile());
				outputFilefc.setCurrentDirectory(file.getParentFile());

				BufferedWriter output = new BufferedWriter(new FileWriter(file));
				output.write("nbVar=" + nbVar);
				output.write(eol);
				output.write("nbReal=" + realisationField.getText());
				output.write(eol);
				for (int ik = 0; ik < nbVar; ik++) {
					output.write("variable" + ik + "="
							+ varNamesPanel.getName(ik));
					output.write(";" + distList[ik].getType());
					for (int ih = 0; ih < distList[ik].getNb(); ih++)
						output.write(";" + distList[ik].getField(ih));
					output.write(eol);
				}
				output.write("expression="
						+ expressionField.getText().replace("\n", ";"));
				output.write(eol);
				if (outputFileField.getText().trim().equals(""))
					output.write("outputFile=no-output");
				else
					output.write("outputFile="
							+ outputFileField.getText().trim());
				output.write(eol);
				output.write("correlation=" + correlation.isSelected());
				output.write(eol);
				if (correlation.isSelected()) {
					output.write("copula=" + coreTable.getTypeIndex());
					output.write(eol);
					if (coreTable.getTypeIndex() == 1) {
						output.write("copulaValue=" + coreTable.getParam(0));
						output.write(eol);

					}
					output.write("correlationValue");
					for (int ii = 0; ii < nbVar; ii++) {
						for (int ij = ii + 1; ij < nbVar; ij++) {
							output.write(";" + coreTable.getField(ii, ij));
						}
					}
				}

				output.close();
				JOptionPane.showMessageDialog(this,
						"Parameters successfully saved to file");
			} catch (IOException e) {
				e.printStackTrace();
				JOptionPane.showMessageDialog(this,
						"Impossible to save to file");
			}

		}

	}

	public void loadParam(File file) {

		try {

			FileInputStream fstream = new FileInputStream(file);
			DataInputStream in = new DataInputStream(fstream);
			BufferedReader br = new BufferedReader(new InputStreamReader(in));
			String strLine;
			strLine = br.readLine();
			int tempInt = Integer.parseInt(strLine.split("=")[strLine
					.split("=").length - 1]);
			variableField.setSelectedIndex(tempInt - 1);
			strLine = br.readLine();
			realisationField
					.setText(strLine.split("=")[strLine.split("=").length - 1]);
			for (int ik = 0; ik < nbVar; ik++) {
				strLine = br.readLine();
				String nameVar = strLine.split(";")[0];
				varNamesPanel.setName(ik,
						nameVar.split("=")[nameVar.split("=").length - 1]);
				distList[ik].setType(Integer.parseInt(strLine.split(";")[1]));
				for (int ih = 0; ih < distList[ik].getNb(); ih++)
					distList[ik].setField(ih, strLine.split(";")[ih + 2]);
			}
			updateVarNames();
			strLine = br.readLine();
			expressionField.setText(strLine.substring(11).replace(";", "\n"));
			strLine = br.readLine();
			if (strLine.split("=")[strLine.split("=").length - 1]
					.equals("no-output"))
				outputFileField.setText("");
			else
				outputFileField
						.setText(strLine.split("=")[strLine.split("=").length - 1]);
			strLine = br.readLine();
			if (strLine.split("=")[strLine.split("=").length - 1]
					.equals("true"))
				correlation.setSelected(false);
			else
				correlation.setSelected(true);
			correlation.doClick();
			if (correlation.isSelected()) {
				strLine = br.readLine();
				int typeCorelation = Integer
						.parseInt(strLine.split("=")[strLine.split("=").length - 1]);
				coreTable.setType(typeCorelation);
				if (typeCorelation == 1) {
					strLine = br.readLine();
					coreTable.setParam(0,
							strLine.split("=")[strLine.split("=").length - 1]);
				}

				strLine = br.readLine();
				int readValue = 1;
				for (int ii = 0; ii < nbVar; ii++) {
					for (int ij = ii + 1; ij < nbVar; ij++) {
						coreTable.setField(ii, ij,
								strLine.split(";")[readValue++]);
					}
				}
			}

			in.close();
		} catch (Exception e) {
			System.err.println("Error: " + e.getMessage());
			JOptionPane.showMessageDialog(this, "Not a valid file");
		}

	}

	public void loadParam() {
		returnVal = paramFilefc.showOpenDialog(UncertaintyMachine.this);

		if (returnVal == JFileChooser.APPROVE_OPTION) {
			File file = paramFilefc.getSelectedFile();
			loadParam(file);
		}

	}

	public void resetDefault() {

		File file = new File("./default.um");
		loadParam(file);

	}

	public Font getFontForm() {
		return fontForms;
	}

	public boolean writeScript() {
		// JOptionPane.showMessageDialog(this, "configfile " + tempFile +
		// " successfully created");
		boolean isValid = false;
		scriptFile = new File(tempFile);
		BufferedWriter output;
		try {
			for (int ij = 0; ij < nbVar; ij++) {
				for (int ik = 0; ik < distList[ij].getNb(); ik++) {
					Double.parseDouble(distList[ij].getField(ik));
				}
			}
			int realNumber = (int) new BigDecimal(realisationField.getText())
					.doubleValue();
			for (int ii = 0; ii < nbVar; ii++)
				for (int ij = ii; ij < nbVar; ij++)
					Double.parseDouble(coreTable.getField(ii, ij));

			output = new BufferedWriter(new FileWriter(scriptFile));
			String backslash = System.getProperty("file.separator");

			if (outputFileField.getText().trim().equals(""))
				output.write("outputFile=\"no-output\"");
			else
				output.write("outputFile= \""
						+ outputFileField.getText().trim()
								.replace(backslash, "/") + "\"");
			output.write(eol);

			output.write("set.seed(5)");
			output.write(eol);
			output.write("options(warn=-1)");
			output.write(eol);
			output.write("setwd(\"" + softwareLocation + "\")");
			output.write(eol);
			output.write("source(\"UncertaintyMachine.R\")");
			output.write(eol);

			output.write("varNames= c(\"" + varNamesPanel.getName(0) + "\"");
			for (int ij = 1; ij < nbVar; ij++)
				output.write(",\"" + varNamesPanel.getName(ij) + "\"");
			output.write(")" + eol);

			String[] expreStrings = expressionField.getText().split("\n");
			if (expreStrings.length == 1) {
				output.write("expression=" + "\"" + expressionField.getText()
						+ "\"");
			} else {
				String pretreatment = "";
				for (int ii = 0; ii < (expreStrings.length - 1); ii++)
					pretreatment = pretreatment.concat(expreStrings[ii] + ";");
				output.write("pretreatment=" + "\"" + pretreatment + "\"");
				output.write(eol);
				output.write("expression=" + "\""
						+ expreStrings[expreStrings.length - 1] + "\"");

			}

			output.write(eol);
			output.write("nbVar=" + nbVar);
			output.write(eol);
			output.write("nbReal=" + realNumber);
			output.write(eol);
			output.write("type=integer(nbVar)");
			output.write(eol);
			output.write("parameters=as.list(rep(NA,nbVar))");

			for (int ij = 0; ij < nbVar; ij++) {
				output.write(eol);
				output.write("type[" + (ij + 1) + "]=" + distList[ij].getType());
				for (int ik = 0; ik < distList[ij].getNb(); ik++) {
					output.write(eol);
					if (ik == 0)
						output.write("parameters[[" + (ij + 1) + "]][1]="
								+ distList[ij].getField(ik));
					else
						output.write("parameters[[" + (ij + 1)
								+ "]]=c(parameters[[" + (ij + 1) + "]],"
								+ distList[ij].getField(ik) + ")");

				}
			}
			output.write(eol);
			if (correlation.isSelected() == true) {
				output.write("copulaType=\"" + coreTable.getType() + "\"" + eol);
				if (coreTable.getType().equals("Student")) {
					Double.parseDouble(coreTable.getParam(0));
					output.write("copulaDf=" + coreTable.getParam(0) + eol);
				}

				output.write("correlation=diag(1,nbVar)");
				for (int ii = 0; ii < nbVar; ii++) {
					for (int ij = ii; ij < nbVar; ij++) {
						output.write(eol);
						output.write("correlation[" + (ii + 1) + "," + (ij + 1)
								+ "]=" + coreTable.getField(ii, ij));
						output.write(eol);
						output.write("correlation[" + (ij + 1) + "," + (ii + 1)
								+ "]=" + coreTable.getField(ii, ij));
					}
				}
				output.write(eol
						+ "try(distrib(nbVar,nbReal,varNames,expression,type,parameters,correlation,outputFile,copulaType,copulaDf))");

			} else {
				output.write("correlation=FALSE" + eol);
				output.write("try(distrib(nbVar,nbReal,varNames,expression,type,parameters,correlation,outputFile))");

			}

			output.write(eol);

			// output.write("cat(\"Press return to close\")");
			// output.write(eol);
			// output.write("readLines(\"stdin\", n = 1)");
			// output.write(eol);

			output.write("while(TRUE)");
			output.write(eol);
			output.write("Sys.sleep(10)");
			output.write(eol);

			output.close();
			isValid = true;
		} catch (IOException e2) {

			e2.printStackTrace();
		} catch (NumberFormatException e2) {
			e2.printStackTrace();
			JOptionPane.showMessageDialog(this,
					"One of the number fields is not a valid number");

		}
		return (isValid);
	}

	public void actionPerformed(ActionEvent e) {
		if (e.getSource() == correlation) {
			coreTable = new CorrelationTable(nbVar, varNamesPanel);
			correlationPanel.removeAll();
			correlationPanel.add(correlation, BorderLayout.NORTH);
			if (correlation.isSelected() == true)
				correlationPanel.add(coreTable, BorderLayout.CENTER);
			correlationPanel.updateUI();
		}

		if (e.getSource() == outputFileButton) {
			returnVal = outputFilefc.showOpenDialog(UncertaintyMachine.this);

			if (returnVal == JFileChooser.APPROVE_OPTION) {
				File file = outputFilefc.getSelectedFile();

				paramFilefc.setCurrentDirectory(file.getParentFile());
				outputFilefc.setCurrentDirectory(file.getParentFile());
				// This is where a real application would open the file.
				outputFileField.setText(file.getPath());
			} else {
				outputFileField.setText("");
			}
		}

		if (e.getSource() == variableField) {
			this.updateVarNb();
		}
		if (e.getSource() == resetButton) {
			resetDefault();
		}
		if (e.getSource() == saveButton) {
			saveParam();
		}
		if (e.getSource() == loadButton) {
			loadParam();
		}
		if (e.getSource() == quitButton) {
			System.exit(0);
		}
		if (e.getSource() == abortButton) {
			if (nbProcess > 0) {
				processList.get(nbProcess - 1).destroy();
				processList.remove(nbProcess - 1);
				nbProcess--;
			}
		}

		if (e.getSource() == runButton) {
			runnable = checkParam();
			if (runnable)
				runnable = writeScript();
			if (runnable) {

				if ((System.getProperty("os.name").toLowerCase())
						.indexOf("win") >= 0) {
					String command = "cmd /c start Rscript \"" + tempFile
							+ "\"";

					// String command=
					// "C:\\WINDOWS\\system32\\cmd.exe /K Rscript "+ tempFile;
					try {
						processList.add(Runtime.getRuntime().exec(command));
						nbProcess++;
						Runtime.getRuntime().addShutdownHook(
								new Thread(new Runnable() {
									public void run() {
										for (int ii = nbProcess; ii > 0; ii--) {
											processList.get(nbProcess - 1)
													.destroy();
											nbProcess--;
										}

									}
								}));

					} catch (IOException e1) {
						e1.printStackTrace();
					}

				} else {
					// String command= "xterm -e Rscript "+ tempFile;
					// Runtime rt = Runtime.getRuntime();
					// try {
					// rt.exec(command);
					// } catch (IOException e1) {
					// e1.printStackTrace();
					// }

					String command = "xterm -e Rscript " + tempFile;

					try {
						processList.add(Runtime.getRuntime().exec(command));
						nbProcess++;
						Runtime.getRuntime().addShutdownHook(
								new Thread(new Runnable() {
									public void run() {
										for (int ii = nbProcess; ii > 0; ii--) {
											processList.get(nbProcess - 1)
													.destroy();
											nbProcess--;
										}

									}
								}));

					} catch (IOException e1) {
						e1.printStackTrace();
					}

				}
				runnable = false;
			}
		}

	}

	// Method which check one by one the validity of each parameter of each
	// distribution
	public boolean checkParam() {
		boolean isValid = true;
		for (int ij = 0; ij < nbVar; ij++) {
			String error = distList[ij].checkPararm();
			if (!error.contentEquals("")) {
				JOptionPane.showMessageDialog(this, ("Error in quantity "
						+ varNamesPanel.getName(ij) + ":\n " + error));
				isValid = false;
			}

		}
		return (isValid);
	}

	/**
	 * Create the GUI and show it. For thread safety, this method should be
	 * invoked from the event dispatch thread.
	 */
	private static void createAndShowGUI() {
		// Create and set up the window.
		JFrame frame = new JFrame("NIST Uncertainty Machine v.1.0");
		frame.setDefaultCloseOperation(JFrame.EXIT_ON_CLOSE);

		// Add content to the window.
		frame.add(new UncertaintyMachine());

		// Display the window.
		frame.pack();

		frame.setSize(1000, 550);
		frame.setMinimumSize(new Dimension(1000, 550));
		frame.setVisible(true);
		// frame.setResizable( false );
	}

	public static void main(String[] args) {
		// Schedule a job for the event dispatch thread:
		// creating and showing this application's GUI.
		SwingUtilities.invokeLater(new Runnable() {
			public void run() {

				KeyboardFocusManager.getCurrentKeyboardFocusManager()
						.addPropertyChangeListener("permanentFocusOwner",
								new PropertyChangeListener() {

									@Override
									public void propertyChange(
											final PropertyChangeEvent evt) {
										if (evt.getNewValue() instanceof JTextField) {
											SwingUtilities
													.invokeLater(new Runnable() {
														public void run() {
															JTextField textField = (JTextField) evt
																	.getNewValue();
															textField
																	.selectAll();
														}
													});

										}

									}
								});

				UIManager.put("Label.font", new FontUIResource(new Font(
						"Arial", Font.BOLD, 17)));
				UIManager.put("FormattedTextField.font", new FontUIResource(
						new Font("serif", Font.PLAIN, 16)));
				UIManager.put("CheckBox.font", new FontUIResource(new Font(
						"Arial", Font.BOLD, 16)));
				UIManager.put("TabbedPane.font", new FontUIResource(new Font(
						"Tahoma", Font.BOLD, 14)));
				UIManager.put("OptionPane.font", new FontUIResource(new Font(
						"Arial", Font.PLAIN, 15)));
				UIManager.put("ComboBox.font", new FontUIResource(new Font(
						"Arial", Font.BOLD, 16)));
				UIManager.put("TextArea.font", new FontUIResource(new Font(
						"serif", Font.PLAIN, 16)));
				UIManager.put("TextField.font", new FontUIResource(new Font(
						"serif", Font.PLAIN, 16)));

				createAndShowGUI();
			}
		});
	}

}
